## sanlock 3.9.5

=== Makefile ===
version := $(shell cat VERSION)

SUBDIRS = wdmd src python

.PHONY: all $(SUBDIRS) clean install

all: $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@

src: wdmd

python: src

clean install:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $@; \
	done

=== requirements.txt ===
tox
userstorage>=0.5.1

=== fence_sanlock/Makefile ===
TARGET1 = fence_sanlockd
TARGET2 = fence_sanlock

SOURCE1 = fence_sanlockd.c
SOURCE2 = fence_sanlock.in

OPTIMIZE_FLAG = -O2 -Wp,-D_FORTIFY_SOURCE=2
ifeq ($(DEBUG), 1)
	OPTIMIZE_FLAG = -O0
	CFLAGS += -g
endif

CFLAGS += -D_GNU_SOURCE -g \
	-Wall \
	-Wformat \
	-Wformat-security \
	-Wnested-externs \
	-Wpointer-arith \
	-Wextra -Wshadow \
	-Wcast-align \
	-Wwrite-strings \
	-Waggregate-return \
	-Wstrict-prototypes \
	-Winline \
	-Wredundant-decls \
	-Wno-sign-compare \
	-fexceptions \
	-fasynchronous-unwind-tables \
	-fdiagnostics-show-option \
	$(OPTIMIZE_FLAG) \
	$(NULL)

VER=$(shell cat ../VERSION)
CFLAGS += -DVERSION=\"$(VER)\" -I../src -I../wdmd
CFLAGS += -fPIE -DPIE

LDFLAGS = -Wl,-z,now -Wl,-z,relro -pie
LDADD = -lrt -laio -lblkid -lsanlock -lwdmd

all: $(TARGET1) $(TARGET2)

$(TARGET1): $(SOURCE1)
	$(CC) $(CFLAGS) $(LDFLAGS) $(SOURCE1) $(LDADD) -o $@ -L. -L../src -L../wdmd

$(TARGET2): $(SOURCE2)
	cat $(SOURCE2) | sed \
		-e 's#@VERSION@#${VER}#g' \
	> $(TARGET2)
	chmod 755 $(TARGET2)

clean:
	rm -f *.o *.so *.so.* $(TARGET1) $(TARGET2)

INSTALL=install

DESTDIR=
BINDIR=/usr/sbin
LIBDIR=/usr/lib64
HEADIR=/usr/include
MANDIR=/usr/share/man

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -c -m 755 $(TARGET1) $(TARGET2) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -m 644 fence_sanlock.8 $(DESTDIR)/$(MANDIR)/man8/
	$(INSTALL) -m 644 fence_sanlockd.8 $(DESTDIR)/$(MANDIR)/man8/

=== reset/Makefile ===
include ../common.mk

TARGET1 = sanlk-resetd
TARGET2 = sanlk-reset

SOURCE1 = sanlk_resetd.c
SOURCE2 = sanlk_reset.c

VER=$(shell cat ../VERSION)
CFLAGS += -DVERSION=\"$(VER)\" -I../src -I../wdmd

CFLAGS += -fPIE -DPIE

LDFLAGS += -Wl,-z,relro -pie

LDADD = -lsanlock -lwdmd

all: $(TARGET1) $(TARGET2)

$(TARGET1): $(SOURCE1)
	$(CC) $(CFLAGS) $(LDFLAGS) $(SOURCE1) $(LDADD) -o $@ -L. -L../src -L../wdmd

$(TARGET2): $(SOURCE2)
	$(CC) $(CFLAGS) $(LDFLAGS) $(SOURCE2) $(LDADD) -o $@ -L. -L../src -L../wdmd

clean:
	rm -f *.o *.so *.so.* $(TARGET1) $(TARGET2)

INSTALL=install

DESTDIR=
BINDIR=/usr/sbin
LIBDIR=/usr/lib64
HEADIR=/usr/include
MANDIR=/usr/share/man

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -c -m 755 $(TARGET1) $(TARGET2) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -m 644 sanlk-reset.8 $(DESTDIR)/$(MANDIR)/man8/
	$(INSTALL) -m 644 sanlk-resetd.8 $(DESTDIR)/$(MANDIR)/man8/

=== src/Makefile ===
# Copyright 2010-2011 Red Hat, Inc.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License v2 or (at your option) any later version.

include ../common.mk

CMD_TARGET = sanlock
HEADER_TARGET = sanlock.h sanlock_rv.h sanlock_resource.h sanlock_admin.h sanlock_direct.h
MAN_TARGET = sanlock.8

SOMAJOR=1
SOMINOR=0

LIB_ENTIRE_TARGET = libsanlock
LIB_CLIENT_TARGET = libsanlock_client
LIBPC_ENTIRE_TARGET = libsanlock.pc
LIBPC_CLIENT_TARGET = libsanlock_client.pc
LIBSO_ENTIRE_TARGET = $(LIB_ENTIRE_TARGET).so.$(SOMAJOR).$(SOMINOR)
LIBSO_CLIENT_TARGET = $(LIB_CLIENT_TARGET).so.$(SOMAJOR).$(SOMINOR)

CMD_SOURCE = \
	crc32c.c \
	delta_lease.c \
	direct.c \
	diskio.c \
	ondisk.c \
	sizeflags.c \
	helper.c \
	lockspace.c \
	lockfile.c \
	log.c \
	main.c \
	paxos_lease.c \
	task.c \
	timeouts.c \
	resource.c \
	rindex.c \
	watchdog.c \
	monotime.c \
	cmd.c \
	client_cmd.c \
	sanlock_sock.c \
	env.c

LIB_ENTIRE_SOURCE = \
	client.c \
	sanlock_sock.c \
	crc32c.c \
	diskio.c \
	ondisk.c \
	sizeflags.c \
	delta_lease.c \
	paxos_lease.c \
	rindex.c \
	direct.c \
	task.c \
	timeouts.c \
	direct_lib.c \
	monotime.c \
	env.c

LIB_CLIENT_SOURCE = \
	client.c \
	sanlock_sock.c \
	env.c

LIBPC_ENTIRE_SOURCE = libsanlock.pc.in
LIBPC_CLIENT_SOURCE = libsanlock_client.pc.in

VER=$(shell cat ../VERSION)
CFLAGS += -DVERSION=\"$(VER)\"

CMD_CFLAGS = $(CFLAGS) -fPIE -DPIE
LIB_ENTIRE_CFLAGS = $(CFLAGS) -fPIC
LIB_CLIENT_CFLAGS = $(CFLAGS) -fPIC

CMD_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie
LIB_ENTIRE_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie
LIB_CLIENT_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie

CMD_LDADD = -lpthread -luuid -lrt -laio -lblkid -lsanlock -L../wdmd -lwdmd
LIB_ENTIRE_LDADD = -lpthread -lrt -laio -lblkid -L../wdmd -lwdmd

all: $(LIBSO_ENTIRE_TARGET) $(LIBSO_CLIENT_TARGET) $(CMD_TARGET) $(LIBPC_ENTIRE_TARGET) $(LIBPC_CLIENT_TARGET)

$(LIBSO_ENTIRE_TARGET): $(LIB_ENTIRE_SOURCE)
	$(CC) $(LIB_ENTIRE_CFLAGS) $(LIB_ENTIRE_LDFLAGS) -shared -o $@ -Wl,-soname=$(LIB_ENTIRE_TARGET).so.$(SOMAJOR) $^ $(LIB_ENTIRE_LDADD)
	ln -sf $(LIBSO_ENTIRE_TARGET) $(LIB_ENTIRE_TARGET).so
	ln -sf $(LIBSO_ENTIRE_TARGET) $(LIB_ENTIRE_TARGET).so.$(SOMAJOR)

$(LIBSO_CLIENT_TARGET): $(LIB_CLIENT_SOURCE)
	$(CC) $(LIB_CLIENT_CFLAGS) $(LIB_CLIENT_LDFLAGS) -shared -o $@ -Wl,-soname=$(LIB_CLIENT_TARGET).so.$(SOMAJOR) $^
	ln -sf $(LIBSO_CLIENT_TARGET) $(LIB_CLIENT_TARGET).so
	ln -sf $(LIBSO_CLIENT_TARGET) $(LIB_CLIENT_TARGET).so.$(SOMAJOR)

$(CMD_TARGET): $(LIBSO_ENTIRE_TARGET) $(CMD_SOURCE)
	$(CC) $(CMD_CFLAGS) $(CMD_LDFLAGS) $(CMD_SOURCE) $(CMD_LDADD) -o $@ -L.

$(LIBPC_ENTIRE_TARGET): $(LIBPC_ENTIRE_SOURCE)
	sed -e "s/@VERSION@/$(VER)/" $(LIBPC_ENTIRE_SOURCE) > $(LIBPC_ENTIRE_TARGET)

$(LIBPC_CLIENT_TARGET): $(LIBPC_CLIENT_SOURCE)
	sed -e "s/@VERSION@/$(VER)/" $(LIBPC_CLIENT_SOURCE) > $(LIBPC_CLIENT_TARGET)

clean:
	rm -f *.o *.so *.so.* $(CMD_TARGET) $(LIBSO_ENTIRE_TARGET) $(LIBSO_CLIENT_TARGET) $(LIBPC_ENTIRE_TARGET) $(LIBPC_CLIENT_TARGET)

INSTALL=install

DESTDIR=
BINDIR=/usr/sbin
LIBDIR=/usr/lib64
HEADIR=/usr/include
MANDIR=/usr/share/man

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -d $(DESTDIR)/$(HEADIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -d $(DESTDIR)/$(LIBDIR)/pkgconfig
	$(INSTALL) -c -m 755 $(CMD_TARGET) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -c -m 755 $(LIBSO_ENTIRE_TARGET) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -c -m 755 $(LIBSO_CLIENT_TARGET) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -c -m 644 $(LIBPC_ENTIRE_TARGET) $(DESTDIR)/$(LIBDIR)/pkgconfig
	$(INSTALL) -c -m 644 $(LIBPC_CLIENT_TARGET) $(DESTDIR)/$(LIBDIR)/pkgconfig
	cp -a $(LIB_ENTIRE_TARGET).so $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_CLIENT_TARGET).so $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_ENTIRE_TARGET).so.$(SOMAJOR) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_CLIENT_TARGET).so.$(SOMAJOR) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -c -m 644 $(HEADER_TARGET) $(DESTDIR)/$(HEADIR)
	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8/

=== wdmd/Makefile ===
# Copyright (C) 2011 Red Hat, Inc.  All rights reserved.
#
# This copyrighted material is made available to anyone wishing to use,
# modify, copy, or redistribute it subject to the terms and conditions
# of the GNU General Public License v2 or (at your option) any later version.

include ../common.mk

CMD_TARGET = wdmd
LIB_TARGET = libwdmd
HEADER_TARGET = wdmd.h
MAN_TARGET = wdmd.8
TEST_TARGET = wdmd_client

SOMAJOR=1
SOMINOR=0
SHLIB_TARGET = $(LIB_TARGET).so.$(SOMAJOR).$(SOMINOR)

CMD_SOURCE = main.c wdmd_sock.c

LIB_SOURCE = client.c wdmd_sock.c

TEST_SOURCE = wdmd_client.c

VER=$(shell cat ../VERSION)
CFLAGS += -DVERSION=\"$(VER)\"

CMD_CFLAGS = $(CFLAGS) -fPIE -DPIE
LIB_CFLAGS = $(CFLAGS) -fPIC

CMD_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie
LIB_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie

CMD_LDADD = -lwdmd -lrt

TEST_LDFLAGS = $(LDFLAGS) -Wl,-z,relro -pie -lwdmd

all: $(SHLIB_TARGET) $(CMD_TARGET)

$(SHLIB_TARGET): $(LIB_SOURCE)
	$(CC) $(LIB_CFLAGS) $(LIB_LDFLAGS) -shared -o $@ -Wl,-soname=$(LIB_TARGET).so.$(SOMAJOR) $^
	ln -sf $(SHLIB_TARGET) $(LIB_TARGET).so
	ln -sf $(SHLIB_TARGET) $(LIB_TARGET).so.$(SOMAJOR)

$(CMD_TARGET): $(SHLIB_TARGET) $(CMD_SOURCE)
	$(CC) $(CMD_CFLAGS) $(CMD_LDFLAGS) $(CMD_SOURCE) $(CMD_LDADD) -o $@ -L.

$(TEST_TARGET): $(SHLIB_TARGET) $(TEST_SOURCE)
	$(CC) $(CMD_CFLAGS) $(TEST_LDFLAGS) $(TEST_SOURCE) $(CMD_LDADD) -o $@ -L.

clean:
	rm -f *.o *.so *.so.* $(CMD_TARGET) $(TEST_TARGET)


INSTALL=install

DESTDIR=
BINDIR=/usr/sbin
LIBDIR=/usr/lib64
HEADIR=/usr/include
MANDIR=/usr/share/man

.PHONY: install
install: all
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -d $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -d $(DESTDIR)/$(HEADIR)
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man8
	$(INSTALL) -c -m 755 $(CMD_TARGET) $(DESTDIR)/$(BINDIR)
	$(INSTALL) -c -m 755 $(SHLIB_TARGET) $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_TARGET).so $(DESTDIR)/$(LIBDIR)
	cp -a $(LIB_TARGET).so.$(SOMAJOR) $(DESTDIR)/$(LIBDIR)
	$(INSTALL) -c -m 644 $(HEADER_TARGET) $(DESTDIR)/$(HEADIR)
	$(INSTALL) -m 644 $(MAN_TARGET) $(DESTDIR)/$(MANDIR)/man8

=== debian/changelog ===
sanlock (3.9.5-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream mailing list as contact in d/copyright.
  * Use upstream systemd service files.
  * Patches:
    - Rebase patches.
    - Add patch to include documentation keys in systemd service files.
    - Add patch for init compatibility in systemd service files.
    - Add patch to change syslog.target to syslog.socket.
  * Update symbols file.
  * Use upstream file for enabling watchdog.
  * Update copyright year on myself.
  * Add lintian override for sourcing init functions.
  * Update Standards-Version to 4.7.2, no changes needed.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Mon, 10 Mar 2025 19:58:48 +0100

=== debian/control ===
Source: sanlock
Section: libs
Priority: optional
Maintainer: Håvard F. Aasen <havard.f.aasen@pfft.no>
Build-Depends:
 debhelper-compat(=13),
 dh-sequence-python3 <!nopython>,
 libaio-dev,
 libblkid-dev,
 libpython3-dev <!nopython>,
 python3-dev:native <!nopython>,
 python3-setuptools <!nopython>,
 uuid-dev,
Standards-Version: 4.7.2
Homepage: https://www.pagure.io/sanlock/
Vcs-Browser: https://salsa.debian.org/haava/sanlock
Vcs-Git: https://salsa.debian.org/haava/sanlock.git
Rules-Requires-Root: no

Package: sanlock
Architecture: linux-any
Section: utils
Depends:
 adduser,
 libsanlock1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 python3-sanlock,
 sanlk-reset,
Description: Shared storage lock manager
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains the binaries and private shared libraries.

Package: sanlk-reset
Architecture: linux-any
Section: utils
Depends:
 libsanlock1 (= ${binary:Version}),
 sanlock (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Host reset daemon and client using sanlock
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains the reset daemon and client.
 A cooperating host running the daemon can be reset by a host
 running the client, so long as both maintain access to a
 common sanlock lockspace.

Package: libsanlock-client1
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Shared storage lock manager (client library)
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains the public shared library for libvirt.

Package: libsanlock1
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Shared storage lock manager (shared library)
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains libsanlock shared library.

Package: libsanlock-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends:
 libsanlock-client1 (= ${binary:Version}),
 libsanlock1 (= ${binary:Version}),
 ${misc:Depends},
Description: Shared storage lock manager (development files)
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains the header files and static libraries.

Package: python3-sanlock
Architecture: linux-any
Multi-Arch: same
Build-Profiles: <!nopython>
Section: python
Depends:
 libsanlock1 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
Description: Python3 bindings to shared storage lock manager
 Sanlock ensures that single disk cannot be used by more than
 one running VM at a time, across any host in a network.
 .
 This package contains the Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

FLAGS = LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} LIBDIR_NAME=

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -D wdmd -- $(FLAGS)
	dh_auto_build -D src -- $(FLAGS)
	dh_auto_build -D reset
ifeq (,$(filter nopython,$(DEB_BUILD_PROFILES)))
	dh_auto_build -D python --buildsystem=pybuild
endif

override_dh_auto_configure:
	dh_auto_configure -D wdmd
	dh_auto_configure -D src
	dh_auto_configure -D reset
ifeq (,$(filter nopython,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -D python --buildsystem=pybuild
endif

override_dh_auto_install:
	dh_auto_install -D wdmd -- $(FLAGS)
	dh_auto_install -D src -- $(FLAGS)
	dh_auto_install -D reset
ifeq (,$(filter nopython,$(DEB_BUILD_PROFILES)))
	dh_auto_install -D python --buildsystem=pybuild
endif

override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/sanlock

execute_after_dh_install:
	install -D -m 0755 init.d/systemd-wdmd debian/sanlock/usr/lib/systemd/systemd-wdmd
	install -D -m 0644 init.d/sanlock.service.native debian/sanlock/usr/lib/systemd/system/sanlock.service

override_dh_installsystemd:
	dh_installsystemd --name=wdmd --no-stop-on-upgrade
	dh_installsystemd --name=sanlock --no-stop-on-upgrade
	dh_installsystemd --name=sanlk-resetd --no-enable --no-start

override_dh_installinit:
	dh_installinit -psanlock --name=wdmd --no-stop-on-upgrade
	dh_installinit -psanlock --name=sanlock --no-stop-on-upgrade

## sanlock 4.2.0

=== debian/changelog ===
sanlock (4.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Patches:
    - Rebase patches.
    - Drop two patches included upstream.
  * Update symbol files.
  * Update watch file to version 5.
  * Remove RRR, used value is now default.
  * Remove lintian override as a fix was implemented in lintian.
    See #1099868 for more information.
  * Change CI from hard-coded URL in GitLab to debian/salsa-ci.yml.
  * d/rules:
    - Update d/rules to clean the 'reset' directory.
    - Delete *.egg-info path as part of clean stage, this also deletes the
      d/source/options file.

 -- Håvard F. Aasen <havard.f.aasen@pfft.no>  Sun, 16 Nov 2025 07:33:49 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 Homepage: https://www.pagure.io/sanlock/
 Vcs-Browser: https://salsa.debian.org/haava/sanlock
 Vcs-Git: https://salsa.debian.org/haava/sanlock.git
-Rules-Requires-Root: no
 
 Package: sanlock
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,12 @@
 
 %:
 	dh $@
+
+execute_after_dh_auto_clean:
+	dh_auto_clean -D reset
+ifeq (,$(filter nopython,$(DEB_BUILD_PROFILES)))
+	rm -rf $(CURDIR)/python/*.egg-info/
+endif
 
 override_dh_auto_build:
 	dh_auto_build -D wdmd -- $(FLAGS)
